--	Author:			Arnaud Lagger, arnaud.lagger@epfl.ch
--
--	Version:		pipeline, optimized version of DES algorithm
--

library ieee;

use ieee.std_logic_1164.all;

entity converter is port
(
	input	:	in std_logic_vector(1 to 16);
	clk	:	in std_logic;
	load_data	:	in	std_logic;
	output	:	out std_logic_vector (1 to 64)
);
end converter;

architecture behavior of converter is
	signal memory	:	std_logic_vector( 1 to 48);
	type state_type is (load1, load2, load3, unload);
	signal state,f_state: state_type;
begin

process(state,input,memory)
begin

case state is

	when load1 =>
		memory <= input & memory(1 to 32);
		f_state <= load2;

	when load2 =>
		memory <= input & memory(1 to 32);
		f_state <= load3;

	when load3 =>
		memory <= input & memory(1 to 32);
		f_state <= unload;

	when unload =>
		output <= memory & input;
		f_state <= unload;
end case;

end process;

process (clk,load_data)
begin

if (clk'event and clk = '1') then
	state <= f_state;
end if;

if(load_data='1') then
	state <= load1;
end if;

end process;

end behavior;