--	Author:			Arnaud Lagger, arnaud.lagger@epfl.ch
--
--	Version:		state machine, optimized version of DES algorithm
--

library ieee;

use ieee.std_logic_1164.all;

entity converter is port
(
	input	:	in std_logic_vector(1 to 16);
	load	:	in std_logic;
	unload	:	in std_logic;
	clk	:	in std_logic;
	output	:	out std_logic_vector (1 to 64)
);
end converter;

architecture behavior of converter is
	signal memory	:	std_logic_vector( 1 to 48);
begin

process(load,clk)
begin
if (clk'event and clk = '1') then
if(load = '1') then
	memory <= input & memory(1 to 32);
end if;
end if;

end process;

process(unload,clk)
begin

if (clk'event and clk = '1') then
if(unload = '1') then
	output <= memory & input;
end if;
end if;

end process;

end behavior;